/* 
 * CUAG AutoUmpire System
 * 
 * Copyright (C) 2003/2004 Matthew Johnson, Adam Biltcliffe,
 * Michael Cripps, Martin O'Leary, Edward Allcutt and James Osborn
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * To Contact the authors, please email assassins@srcf.ucam.org
 *
 */

package org.ucam.srcf.assassins;

import java.io.IOException;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Vector;


import cx.ath.matthew.cgi.CGI;
import cx.ath.matthew.cgi.HiddenField;
import cx.ath.matthew.cgi.SubmitButton;
import cx.ath.matthew.cgi.CGIHeaderSentException;
import cx.ath.matthew.cgi.CheckBox;
import cx.ath.matthew.cgi.DisplayField;
import cx.ath.matthew.cgi.TextField;

import org.ucam.srcf.assassins.exceptions.AssassinSQLException;
import org.ucam.srcf.assassins.exceptions.StateBuilderException;
import org.ucam.srcf.assassins.xml.Config;

public class CGIAddEvent implements CGICommand
{
   Event addEvent(CGI cgi, Map plugins, Map params, boolean withreport) throws AssassinSQLException, IOException, ParseException , StateBuilderException
   { 
      // By Mike - fixx0red by matt
      if ("3".equals(params.get("pass"))){ // pass 3
         Event e = (Event) params.get("event");
         e.setEventTime(Tools.unFormatTime((String)params.get("event-time")));
         e.setHeadline((String) params.get("headline"));
         e.setActive("on".equals(params.get("active")) ? true : false);
         e.setVisible("on".equals(params.get("visible")) ? true : false);

         LightweightStateBuilder lsb = new LightweightStateBuilder(Tools.getNowTime());
         for (Iterator i = e.getParticipants().values().iterator(); i.hasNext();) {
            lsb.registerInterest((Assassin)i.next());
         }
         Map statev = null;
         try {
            statev = Tools.viewerifyStateMap(lsb.generateState());
         } catch (StateBuilderException sbe) {
            cgi.out("<h2>State Building failed! Very bad!!</h2>");
            cgi.flush();
            throw new RuntimeException();
         }

         HTMLForm form;
         if (withreport)
            form = new HTMLForm("umpire.cgi?add-event-with-report", "No More Deaths");
         else
            form = new HTMLForm("umpire.cgi?add-event", "No More Deaths");
         form.addField(new HiddenField("pass","4"));
         form.addField(new HiddenField("index","0"));

         EventViewer ev = (EventViewer) e.getViewer();
         Iterator i = params.keySet().iterator();
         while (i.hasNext()) {
            String key = (String) i.next();
            if (key.startsWith("assassin")) {
               String idx = key.substring(8);
               Assassin a = (Assassin) params.get(key);
               Pseudonym p = (Pseudonym) params.get("pseudonym"+idx);
               int id = Integer.parseInt(idx) + 1;
               if ("on".equals(params.get("nopseud"+idx)))
                  e.setParticipant(id, a, null);
               else
                  e.setParticipant(id, a, p);
               AssassinViewer av = (AssassinViewer) a.getViewer();
               Iterator ps = plugins.values().iterator();
               while (ps.hasNext()) {
                  Plugin pl = (Plugin) ps.next();
                  Vector qs = CGITools.parseQuestions(pl, params, (id-1)*100);
                  pl.participantAdded(ev, av, statev, qs);
               }
            }
         }
         Event.commitAll();
         Iterator plgs = plugins.values().iterator();
         umpirecgi.currentAuth.clearSessionQuestions();
         while (plgs.hasNext()) {
            Plugin pl = (Plugin) plgs.next();
            Vector qs = pl.eventAdded(ev, statev, null);
            Iterator qi = qs.iterator();
            for (int j=0; qi.hasNext(); j++) {
               Question q = (Question) qi.next();
               form.addField(CGITools.getPluginField(pl, q, j));
               umpirecgi.currentAuth.addSessionQuestion(pl, q);
            }
         }
         cgi.out("<h2>Add New Event</h2>");
         cgi.out("<p>");
         cgi.out("Add Death");
         cgi.out("</p>");
         form.addField(new CanonicalEntityField("killer","Select killer (PERSON WHO HAS BEEN KILLING PEOPLE):",e.getParticipants().values(),(CanonicalEntity) null));
         form.addField(new CanonicalEntityField("victim","Select victim (DEAD PERSON):",e.getParticipants().values(),(CanonicalEntity) null));
         Event.commitAll();
         form.addField(new HiddenField("event",""+e));
         form.addField(new SubmitButton("submit","Add Death"));
         form.display(cgi); 
         return null;
      } else if ("4".equals(params.get("pass")))  { // pass 4
         if ("Add Death".equals(params.get("submit"))) {
            // If we want to add another death
            HTMLForm form;
            if (withreport) 
               form = new HTMLForm("umpire.cgi?add-event-with-report", "No More Deaths");
            else
               form = new HTMLForm("umpire.cgi?add-event", "No More Deaths");
            Event e = (Event) params.get("event");
            form.addField(new HiddenField("event",""+e));
            form.addField(new HiddenField("pass","4"));

            Iterator ps = plugins.values().iterator();
            LightweightStateBuilder lsb = new LightweightStateBuilder(Tools.getNowTime());
            for (Iterator i = e.getParticipants().values().iterator(); i.hasNext();) {
               lsb.registerInterest((Assassin)i.next());
            }
            Map statev = null;
            try {
               statev = Tools.viewerifyStateMap(lsb.generateState());
            } catch (StateBuilderException sbe) {
               cgi.out("<h2>State Building failed! Very bad!!</h2>");
               cgi.flush();
               throw new RuntimeException();
            }
            EventViewer ev = (EventViewer) e.getViewer();
            ps = plugins.values().iterator();
            while (ps.hasNext()) {
               Plugin p = (Plugin) ps.next();
               Vector qs = CGITools.parseQuestions(p, params);
               p.eventAdded(ev, statev, qs);
            }
            Event.commitAll();
            umpirecgi.currentAuth.clearSessionQuestions();

            Assassin victim = (Assassin) params.get("victim");
            Assassin killer = (Assassin) params.get("killer");
            Death d = new Death(killer,victim);
            e.addStateChange(d);
            Event.commitAll();
            cgi.out("<h2>Add New Event</h2>");
            cgi.out("<h4>Deaths:</h4>");
            cgi.out("<ul>");
            List l = e.getStateChanges();
            Iterator i = l.iterator();
            while (i.hasNext()) {
               StateChange sc = (StateChange) i.next();
               if (sc instanceof Death)
                  cgi.out("   <li>"+((Assassin) sc.getEntity()).getPlayer().getName()+
                        " killed "+sc.getAssassin().getPlayer().getName()+"</li>");
            }
            cgi.out("</ul>");

            cgi.out("<p>");
            cgi.out("Add Death, Submit Form to continue without adding another death");
            cgi.out("</p>");
            form.addField(new CanonicalEntityField("killer","Select killer (PERSON WHO HAS BEEN KILLING PEOPLE):",e.getParticipants().values(),(CanonicalEntity) null));
            form.addField(new CanonicalEntityField("victim","Select victim (DEAD PERSON):",e.getParticipants().values(),(CanonicalEntity) null));
            form.addField(new SubmitButton("submit","Add Death"));
            form.display(cgi); 
         } else {
            // Done adding deaths, let's ask plugins
            Event e = (Event) params.get("event");

            cgi.out("<h2>Add New Event</h2>");
            cgi.out("<div class=\"infomessage\">");
            cgi.out("   <p><b>Event Added</b></p>");
            cgi.out("   <p>Additional questions:</p>");
            cgi.out("</div>");

            HTMLForm form;
            if (withreport) 
               form = new HTMLForm("umpire.cgi?add-event-with-report", "Answer");
            else
               form = new HTMLForm("umpire.cgi?add-event", "Answer");
            form.addField(new HiddenField("pass", "5"));

            List plgObjs = new ArrayList(plugins.values());
            Collections.sort(plgObjs, new PluginPriorityComparator());
            Iterator ps = plgObjs.iterator();
            LightweightStateBuilder lsb = new LightweightStateBuilder(Tools.getNowTime());
            for (Iterator i = e.getParticipants().values().iterator(); i.hasNext();) {
               lsb.registerInterest((Assassin)i.next());
            }
            Map statev = null;
            try {
               statev = Tools.viewerifyStateMap(lsb.generateState());
            } catch (StateBuilderException sbe) {
               cgi.out("<div class=\"errormessage\">");
               cgi.out("  <p><b>Internal Error</b></p>");
               cgi.out("  <p>State Building failed! Very bad!!</p>");
               cgi.out("</div>");
               cgi.flush();
               throw new RuntimeException();
            }
            EventViewer ev = (EventViewer) e.getViewer();
            ps = plugins.values().iterator();
            while (ps.hasNext()) {
               Plugin p = (Plugin) ps.next();
               Vector qs = CGITools.parseQuestions(p, params);
               p.eventAdded(ev, statev, qs);
            }
            Event.commitAll();
            umpirecgi.currentAuth.clearSessionQuestions();

            Iterator scs = e.getStateChanges().iterator();
            for (int idx = 0; scs.hasNext(); idx++) {
               StateChange sc = (StateChange) scs.next();
               ps = plugins.values().iterator();
               while (ps.hasNext()) {
                  Plugin p = (Plugin) ps.next();
                  Vector qs = p.stateChangeAdded(sc, statev, null);
                  Iterator qi = qs.iterator();
                  for (int i=idx*100; qi.hasNext(); i++) {
                     Question q = (Question) qi.next();
                     form.addField(CGITools.getPluginField(p, q, i));
                     umpirecgi.currentAuth.addSessionQuestion(p, q);
                  }
               }
            }

            form.addField(new HiddenField("event", ""+e));
            form.display(cgi);
         }
         return null;
      } else if ("5".equals(params.get("pass"))) {// pass 5
         Event e = (Event) params.get("event");
         List plgObjs = new ArrayList(plugins.values());
         Collections.sort(plgObjs, new PluginPriorityComparator());
         Iterator ps = plgObjs.iterator();
         LightweightStateBuilder lsb = new LightweightStateBuilder(Tools.getNowTime());
         for (Iterator i = e.getParticipants().values().iterator(); i.hasNext();) {
            lsb.registerInterest((Assassin)i.next());
         }
         Map statev = null;
         try {
            statev = Tools.viewerifyStateMap(lsb.generateState());
         } catch (StateBuilderException sbe) {
            cgi.out("<div class=\"errormessage\">");
            cgi.out("  <p><b>Internal Error</b></p>");
            cgi.out("  <p>State Building failed! Very bad!!</p>");
            cgi.out("</div>");
            cgi.flush();
            throw new RuntimeException();
         }
         Iterator scs = e.getStateChanges().iterator();
         for (int idx = 0; scs.hasNext(); idx++) {
            StateChange sc = (StateChange) scs.next();
            ps = plugins.values().iterator();
            while (ps.hasNext()) {
               Plugin p = (Plugin) ps.next();
               Vector qs = CGITools.parseQuestions(p, params, idx*100);
               p.stateChangeAdded(sc, statev, qs);
            }
         }
         Event.commitAll();
         umpirecgi.currentAuth.clearSessionQuestions();

         cgi.out("<h2>Add New Event</h2>");
         cgi.out("<div class=\"donemessage\">");
         cgi.out("  <p><b>New Event Added Successfully</b></p>");
         cgi.out("  <p>All statechange events added. All questions asked.</p>");
         cgi.out("</div>");
         if (!withreport) try { cgi.header("Refresh", "2; URL=umpire.cgi?edit-event,"+e.getEid()); } catch (CGIHeaderSentException CGIHSe) {} 
         return e;
      } else if ("2".equals(params.get("pass"))) {// pass 2
         HTMLForm form;
         if (withreport) 
            form = new HTMLForm("umpire.cgi?add-event-with-report", "Add");
         else
            form = new HTMLForm("umpire.cgi?add-event", "Add");
         form.addField(new HiddenField("pass","3"));
         Object o = params.get("assassins");
         List as = new LinkedList();
         if (o instanceof List) 
            as = (List) o;
         else if (o instanceof Assassin)
            as.add(o);
         LightweightStateBuilder lsb = new LightweightStateBuilder(Tools.getNowTime());
         for (Iterator i=as.iterator(); i.hasNext();) {
            lsb.registerInterest((Assassin)i.next());
         }
         Map myState = null;
         try {
            myState=lsb.generateState();
         } catch (StateBuilderException sbe) {
            cgi.out("<div class=\"errormessage\">");
            cgi.out("  <p><b>Internal Error</b></p>");
            cgi.out("  <p>State Building failed! Very bad!!</p>");
            cgi.out("</div>");
            cgi.flush();
            throw new RuntimeException();
         }
         Map statev = Tools.viewerifyStateMap(myState);
         Iterator i = as.iterator();
         cgi.out("<h2>Add New Event</h2>");
         cgi.out("<p>");
         cgi.out("Select Pseudonyms");
         cgi.out("</p>");
         Event e = new Event();
         EventViewer ev = (EventViewer) e.getViewer();
         int idx=0;
         Vector qs;
         while (i.hasNext()) {
            Assassin a;
            a = (Assassin) i.next();
            AssassinViewer av = (AssassinViewer) a.getViewer();
            form.addField(new HiddenField("assassin"+idx,""+a));
            form.addField(new CanonicalEntityField("pseudonym"+idx,(idx+1)+"."+a.getPlayer().getName(),((AssassinState) myState.get(a)).getPseudonyms(),(CanonicalEntity) null));
            form.addField(new CheckBox("nopseud"+idx, "Use Real Name", false));
            Iterator j = plugins.values().iterator();
            while (j.hasNext()) {
               Plugin p = (Plugin) j.next();
               qs = p.participantAdded(ev, av, statev, null);
               Iterator qi = qs.iterator();
               for (int k=idx*100; qi.hasNext(); k++) {
                  Question q = (Question) qi.next();
                  form.addField(CGITools.getPluginField(p, q, k));
                  umpirecgi.currentAuth.addSessionQuestion(p, q);
               }
            }
            ++idx;
         }
         form.addField(new TextField("event-time","Event Time:", Tools.formatTime(Tools.getNowTime())));
         String defheadline = Config.getConfig("vanilla", "default-headline");
         form.addField(new TextField("headline","Headline:", null==defheadline?"":defheadline, 60));
         form.addField(new DisplayField("",
                  "Headlines may contain the special sequences "+
                  "[Pn], [Nn] and [Ln], "+
                  "where n is the participant number.<br/> "+
                  "[Pn] will be replaced by their pseudonym, "+
                  "[Nn] by their name "+
                  "and [Ln] by the list of all their pseudonyms."));
         if (umpirecgi.currentAuth.isAtLeast(AuthLevel.UMPIRE)) {
            form.addField(new CheckBox("active","Make Active?", true));
            form.addField(new CheckBox("visible","Make Visible?", true));
         } else {
            form.addField(new HiddenField("active","on"));
            form.addField(new HiddenField("visible","on"));
         }
         form.addField(new HiddenField("event",""+e));
         form.display(cgi);
         return null;
      } else { // pass 1
         List as = Assassin.getAllAssassinsOrderByRealName();
         if (Debug.debug) Debug.print(umpirecgi.class,  "assassins got: "+as+" ("+as.size()+")");
         cgi.out("<h2>Add New Event</h2>");
         cgi.out("<p>");
         cgi.out("Select the assassins involved in the event: ");
         cgi.out("</p>");
         HTMLForm form;
         if (withreport) 
            form = new HTMLForm("umpire.cgi?add-event-with-report", "Add");
         else
            form = new HTMLForm("umpire.cgi?add-event", "Add");
         form.addField(new MultipleCanonicalEntityField("assassins","",as,(CanonicalEntity) null));
         form.addField(new HiddenField("pass","2"));
         form.display(cgi);
         return null;
      }
   }
   public void command(CGI cgi, Map plugins, Map params, long nowtime) 
      throws AssassinSQLException, IOException, ParseException, StateBuilderException {  addEvent(cgi, plugins, params, false); } 
   public String getName() { return "Add Event"; }
   public String getDescription() { return "Adds an event"; }
   public AuthLevel accessLevel () { return AuthLevel.PLAYER; }
   public String getSection() { return "Event"; }
}

