/* 
 * CUAG AutoUmpire System
 * 
 * Copyright (C) 2003/2004 Matthew Johnson, Adam Biltcliffe,
 * Michael Cripps, Martin O'Leary, Edward Allcutt and James Osborn
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * To Contact the authors, please email assassins@srcf.ucam.org
 *
 */

package org.ucam.srcf.assassins;

import java.io.IOException;
import java.text.ParseException;
import java.util.Map;
import java.util.Iterator;

import cx.ath.matthew.cgi.CGI;
import cx.ath.matthew.cgi.CGIHeaderSentException;
import cx.ath.matthew.cgi.DropDown;
import cx.ath.matthew.cgi.TextArea;
import cx.ath.matthew.cgi.TextField;


import org.ucam.srcf.assassins.exceptions.AssassinSQLException;

public  class CGIAddPlayer implements CGICommand
{
   Player addPlayer(CGI cgi, Map plugins, Map params, boolean withassassin) throws AssassinSQLException, IOException
   {
      if (params.get("submit") != null) {
         Player p = new Player();
         p.setName((String) params.get("name"));
         p.setEmail((String) params.get("email"));
         String college = (String) params.get("manualcol");
         if (null == college || "".equals(college)) college = (String) params.get("college");
         p.setCollege(college);
         p.setAddress((String) params.get("address"));
         p.setWaterStatus((String) params.get("water"));
         p.setNotes((String) params.get("notes"));
         Player.commitAll();
         cgi.out("<div class=\"donemessage\">");
         cgi.out("  <p><b>New Player Added Successfully</b></p>");
         cgi.out("  <p>&nbsp;</p>");
         cgi.out("</div>");
         if (!withassassin) try { cgi.header("Refresh", "2; URL=umpire.cgi"); } catch (CGIHeaderSentException CGIHSe) {} 
         return p;
      }

      else {
         HTMLForm form;

         if (withassassin) form = new HTMLForm("umpire.cgi?add-player-with-assassin", "Add");
         else form = new HTMLForm("umpire.cgi?add-player", "Add");

         form.addField(new TextField("name", "Real Name:", ""));
         form.addField(new TextField("email", "Email:", "@cam.ac.uk"));
         /* Sort the colleges into alphabetical order */
         java.util.Arrays.sort(umpirecgi.colleges);
         form.addField(new DropDown("college", "College:", umpirecgi.colleges, "", false));
         form.addField(new TextField("manualcol", "Enter manual college:", ""));
         form.addField(new TextArea("address", "Address:", ""));
         form.addField(new DropDown("water", "Water Status:", umpirecgi.waterstatuses, "", false));
         form.addField(new TextArea("notes", "Notes (will be sent to assassins):", ""));
         cgi.out("<h2>Add New Player</h2>");
         cgi.out("<p>");
         cgi.out("  Please enter their details below:");
         cgi.out("</p>");
         form.display(cgi);
         return null;
      }
   }
   public void command(CGI cgi, Map plugins, Map params, long nowtime) 
      throws AssassinSQLException, IOException, ParseException { addPlayer(cgi, plugins, params, false); } 
   public String getName() { return "Add Player"; }
   public String getDescription() { return "Adds a player"; }
   public AuthLevel accessLevel () { return AuthLevel.UMPIRE; }
   public String getSection() { return "Assassin"; }
}

